#pragma hdrstop

#include "OPlugin.h"

#pragma package(smart_init)

using namespace OPlugin;

//const char *OPlugin::g_szPluginTable = "OPlugin::CPluginTable";
//const char *OPlugin::g_szPlugins = "OPlugin::CPlugins";

__fastcall CPlugin::CPlugin(AdapterClass* const Adapter):
           CPluginTmp<AdapterClass>(Adapter, Adapter->MainForm())
{
    try
    {
        TForm *Main = Callback->MainForm();
        Top = Main->Top + Main->Height + 2;
        Left = 0;
        Width = Screen->Width;
        Height = Screen->WorkAreaHeight - Top - 2;
    } catch (const Exception &E)
    {
        CatchExceptionMessage("   OPlugin::CPlugin", E);
    } catch (...)
    {
        CatchEllipsisMessage("    OPlugin::CPlugin");
    }
}

/*
void __fastcall OPlugin::CPlugin::WndProc(Messages::TMessage &Message)
{
    switch(Message.Msg)
    {
        case WM_SYSCOMMAND:
            TForm::WndProc(Message);
            if (Message.WParam == SC_CLOSE)
            {
                PostMessage(Callback->MainForm()->Handle,
                            CM_PLUGIN_CLOSE,
                            reinterpret_cast<WPARAM>(Handle), 0);
            }
            break;
        case CM_INIT_COMPLETE:
            OnInitComplete(Message);
            break;
        default:
            TForm::WndProc(Message);
            break;
    }
}

void __fastcall OPlugin::CPlugin::OnInitComplete(Messages::TMessage &Message)
{
    InitComplete();
}
*/

CPluginHandle::CPluginHandle(HINSTANCE DllHandle,
                             PluginClass* const Plugin):
    CPluginHandleTmp<PluginClass>(DllHandle, Plugin)
{
}

/*
OPlugin::CPluginHandle* const OPlugin::CPluginTable::operator[](int FuncID) const
{
    return Find(FuncID);
}

inline OPlugin::CPluginHandle* const OPlugin::CPluginTable::Find(int FuncID) const
{
    const_iterator PH = find(FuncID);
    if (PH != end())
    {
        return PH->second;
    }
    return NULL;
}

bool OPlugin::CPluginTable::Add(int               FuncID,
                                HINSTANCE         DllHandle,
                                CPlugin* const Plugin)
{
    const_iterator PH = find(FuncID);
    if (PH == end())
    {
        map<int, CPluginHandle*>::operator[](FuncID)
            = new OPlugin::CPluginHandle(DllHandle, Plugin);
        return true;
    }
    return false;
}

bool OPlugin::CPluginTable::Remove(int FuncID)
{
    const_iterator PH = find(FuncID);
    if (PH != end())
    {
        if (PH->second) delete PH->second;
        erase(FuncID);
        return true;
    }
    return false;
}
*/

const int CPluginFunc::operator[](HWND PluginHandle) const
{
    return Find(PluginHandle);
}

inline const int CPluginFunc::Find(HWND PluginHandle) const
{
    const_iterator PF = find(PluginHandle);
    if (PF != end())
    {
        return PF->second;
    }
    return 0;
}

bool CPluginFunc::Add(HWND PluginHandle, int FuncID)
{
    const_iterator PF = find(PluginHandle);
    if (PF == end())
    {
        map<HWND, int>::operator[](PluginHandle) = FuncID;
        return true;
    }
    return false;
}

bool CPluginFunc::Remove(HWND PluginHandle)
{
    const_iterator PF = find(PluginHandle);
    if (PF != end())
    {
        erase(PluginHandle);
        return true;
    }
    return false;
}


CPlugins::CPlugins(const RegisterPluginFunctionPointer PRegister,
                   const UnregisterPluginFunctionPointer PUnregister,
                   AdapterClass* const Adapter):
                   CPluginsTmp<PluginTableClass>(PRegister, PUnregister, Adapter)//,
{
    ClassName = "OPlugin::CPlugins";
}

/*
OPlugin::CPlugin* OPlugin::CPlugins::Register(const int FuncID,
                                              const AnsiString DllName)
{
    OPlugin::CPluginHandle *PH = OPlugin::CPluginTable::Find(FuncID);
    if (PH) return PH->Plugin;
    HINSTANCE h = LoadLibrary(DllName.c_str());
    OPlugin::CPlugin *Plugin = NULL;
    if (h)
    {
        typedef OPlugin::CPlugin* __stdcall (*PDllExec)(CMFAAdapter* const);
        PDllExec dllExec = (PDllExec) GetProcAddress(h, "Execute");
        if (dllExec)
        {
            Plugin = dllExec(Adapter);
        } else
        {
            return NULL;
        }
    } else
    {
        return NULL;
    }
    OPlugin::CPluginTable::Add(FuncID, h, Plugin);
    OPlugin::CPluginFunc::Add(Plugin->Handle, FuncID);
    PRegister(FuncID, Plugin);
    return Plugin;
}

bool OPlugin::CPlugins::Unregister(const HWND PluginHandle)
{
    const int FuncID = OPlugin::CPluginFunc::Find(PluginHandle);
    if (!FuncID) return false;
    OPlugin::CPluginHandle* const PH = OPlugin::CPluginTable::Find(FuncID);
    if (!PH) return false;
    PUnregister(FuncID);
    HINSTANCE h = PH->DllHandle;
    typedef void __stdcall (*PFree)(OPlugin::CPlugin*);
    PFree dllExec = (PFree)GetProcAddress(h, "Free");
    if (dllExec)
    {
        dllExec(PH->Plugin);
    }
    OPlugin::CPluginFunc::Remove(PluginHandle);
    OPlugin::CPluginTable::Remove(FuncID);
    FreeLibrary(h);
    return true;
}

OPlugin::CPlugin* OPlugin::CPlugins::operator [](const int FuncID) const
{
    OPlugin::CPluginHandle *PH = OPlugin::CPluginTable::Find(FuncID);
    if (PH) return PH->Plugin;
    return NULL;
}
*/
